package net.northking.cctp.element.basic.enums;

import com.alibaba.fastjson.JSON;
import net.northking.cctp.element.core.type.EnumClass;

import java.util.*;

/**
 * ModeTypeEnum
 *
 * @author fengxiang.zhang
 * @since 1.0
 */
public enum ModeTypeEnum implements EnumClass {

    base("普通模式", "1"),
    advance("高级模式", "2"),
    ;

    private String key;
    private String value;

    ModeTypeEnum(String key, String value) {
        this.key = key;
        this.value = value;
    }

    public static ModeTypeEnum from(String value) {
        for (ModeTypeEnum item : ModeTypeEnum.values()) {
            if (item.value.equals(value)) {
                return item;
            }
        }
        throw new IllegalArgumentException("未知的模式类型:" + value);
    }

    @Override
    public String getEnumData() {
        List<Map<String, Object>> result = new ArrayList<>();
        for (ModeTypeEnum item : EnumSet.allOf(ModeTypeEnum.class)) {
            Map<String, Object> one = new HashMap(1);
            one.put("label", item.key);
            one.put("value", item.value);
            result.add(one);
        }
        return JSON.toJSONString(result);
    }
}
